#define APPNAME  "test - directx"
#define APPTITLE "test - directx"

template<class T> void _RELEASE_(T t)
{
	if( t )
	{
		t->Release();
		t = 0;
	}
}

template<class T> void _DELETE_(T t)
{
	if( t )
	{
		delete t;
		t = 0;
	}
}

#include <windows.h>
#include <time.h>

#include <d3d9.h>
#include <d3dx9.h>
#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "d3d9.lib")
#pragma comment (lib, "d3dx9.lib")
#pragma comment (lib, "winmm.lib")

#include <vector>
#include <fstream>

//ؽ ü Ÿ 
struct Vertex
{
	Vertex(){}
	Vertex(float x, float y, float z, float nx, float ny, float nz, float u, float v)
	{
		 _x = x;   _y = y;   _z = z;
		 _nx = nx; _ny = ny; _nz = nz;
		 _u = u;   _v = v;
	}

	float _x, _y, _z, _nx, _ny, _nz, _u, _v;

	static const DWORD FVF;
};
const DWORD Vertex::FVF = D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1;


bool g_bIsFullScreen = false;	        // is our app Full screen or not
int g_iScreenX = 640, g_iScreenY = 480;	// use this if 'not'
D3DDISPLAYMODE  g_d3ddm = {640, 480, 60, D3DFMT_A8R8G8B8};


BOOL	g_bActive = TRUE;
HWND	g_hWnd = NULL;
HWND    g_hMultiWnd;

LPDIRECT3D9             g_d3d        = NULL; // our main d3d8 interface
LPDIRECT3DDEVICE9       g_d3d_Device = NULL; // our d3d8 device
D3DPRESENT_PARAMETERS	g_d3dpp; 

ID3DXMesh*         g_pMesh = 0;
const DWORD        g_nNumSubsets = 3;
IDirect3DTexture9* g_pTextures[3] = {0, 0, 0};// texture for each subset


LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);


bool WindowInit(HINSTANCE hInst, int nCmdShow);
bool AppInit(HINSTANCE hInst, int nCmdShow);
HRESULT InitD3D(HWND hWnd);
void SetupCamera(HWND hWnd);
bool RenderInit();
void DestroyDirect3D8();
HRESULT ResetDeviceObjects();
HRESULT RenderLoop();
HRESULT Render3D(float timeDelta);
void	DestroyDirect3D8();
void    DumpMesh();

//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		g_bActive = LOWORD(wParam);
		return 0;
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
		{
			DestroyDirect3D8();
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		break;

	case WM_CLOSE:          
		DestroyDirect3D8();
        DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	case WM_SYSCOMMAND:
		// Prevent moving/sizing and power loss in fullscreen mode
		switch( wParam )
		{
			case SC_MOVE:
			case SC_SIZE:
			case SC_MAXIMIZE:
			case SC_KEYMENU:
			case SC_MONITORPOWER:
				if( g_bIsFullScreen)
					return 1;
				break;
		}
		break;

    case WM_NCHITTEST:
       // Prevent the user from selecting the menu in fullscreen mode
        if(g_bIsFullScreen)
              return HTCLIENT;
        break;
/*  콺 Ŀ ʿ   Ѵ
	case WM_SETCURSOR:
		SetCursor (NULL);
		return 0;
		break; 
*/
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//-----------------------------------------------------------------------------
void CreateMultiWindow(HWND hwnd, HINSTANCE hinst)
{
	WNDCLASSEX	wcl;
	RECT		rcWindow;

	// Set up and register toolbar window class
	wcl.cbSize		= sizeof(wcl);
	wcl.style			= CS_HREDRAW | CS_VREDRAW;
	wcl.lpfnWndProc	= WindowProc;
	wcl.cbClsExtra	= 0;
	wcl.cbWndExtra	= 0;
	wcl.hInstance		= hinst;
	wcl.hIcon			= LoadIcon( NULL, IDI_APPLICATION );
	wcl.hCursor		= LoadCursor( NULL, IDC_ARROW );
	wcl.hbrBackground	= (HBRUSH) GetStockObject (COLOR_BACKGROUND);
	wcl.lpszMenuName	= NULL;
	wcl.lpszClassName	= "MultiWindow";	// Registered Class Name
	wcl.hIconSm		= LoadIcon( NULL, IDI_APPLICATION );
    RegisterClassEx(&wcl);
    
	//Figure out position
	GetWindowRect( g_hWnd, &rcWindow );

	//Create Window
	g_hMultiWnd = CreateWindowEx ( 
		WS_EX_LEFT|WS_EX_TOPMOST|WS_EX_TOOLWINDOW,
		"MultiWindow", "MultiWindow",
		WS_BORDER | WS_VISIBLE | WS_MINIMIZEBOX,	
		rcWindow.left+10, rcWindow.top + 10, 
		200, 200, hwnd, NULL, hinst, NULL);

	// Activate edit area
	SetActiveWindow( g_hWnd );
}
//-----------------------------------------------------------------------------
HRESULT RenderMultiWindow (float timeDelta )
{
	HRESULT hr;
	D3DXMATRIX xRot;
	D3DXMatrixRotationX(&xRot, D3DX_PI * 0.2f);

	static float y = 0.0f;
	D3DXMATRIX yRot;
	D3DXMatrixRotationY(&yRot, y);
	y += timeDelta;

	if( y >= 6.28f )
		y = 0.0f;

	D3DXMATRIX world = xRot * yRot;
	g_d3d_Device->SetTransform(D3DTS_WORLD, &world);

    g_d3d_Device->Clear (0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB (0, 0, 0), 1.0f, 0);
    g_d3d_Device->BeginScene ();

	for(int i = 0; i < g_nNumSubsets; i++)
	{
		g_d3d_Device->SetTexture( 0, g_pTextures[i] );
		g_pMesh->DrawSubset( i );
	}

    g_d3d_Device->EndScene ();
    hr = g_d3d_Device->Present (NULL, NULL, g_hMultiWnd, NULL);
	return hr;
}
//-----------------------------------------------------------------------------
bool WindowInit(HINSTANCE hInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (NULL, IDC_ICON);
	wcl.hCursor			= LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	if(g_bIsFullScreen)
	{
		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_POPUP|WS_SYSMENU|WS_VISIBLE, 
			0, 0, 
			g_d3ddm.Width,
			g_d3ddm.Height,
			NULL,
			NULL,
			hInst,
			NULL);
	}
	else
	{
		int sx = GetSystemMetrics (SM_CXSCREEN);
		int sy = GetSystemMetrics (SM_CYSCREEN);

		g_hWnd = CreateWindowEx (
			NULL,
			APPNAME,
			APPTITLE,
			WS_OVERLAPPED | WS_SYSMENU,
			sx/2 - g_iScreenX/2, sy/2 - g_iScreenY/2,
			g_iScreenX,
			g_iScreenY,
			NULL,
			NULL,
			hInst,
			NULL);
	};

	if(!g_hWnd) 
		return false;

	return true;
}
//-----------------------------------------------------------------------------
bool AppInit(HINSTANCE hInst, int nCmdShow)
{
	srand ((unsigned int)time(0)); // randomize timer

	if(!WindowInit (hInst, nCmdShow)) 
		return false;

	CreateMultiWindow( g_hWnd, hInst );
	ShowWindow (g_hWnd, nCmdShow);
	UpdateWindow (g_hWnd);
    
	return true;
}
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	ZeroMemory (&g_d3dpp, sizeof(g_d3dpp));

    if( NULL == ( g_d3d = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

	//ؽ ó 
	D3DCAPS9 caps;
	D3DDEVTYPE deviceType = D3DDEVTYPE_HAL;
	g_d3d->GetDeviceCaps(D3DADAPTER_DEFAULT, deviceType, &caps);
	int vertexProcessing = 0;
	if( caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT )
		vertexProcessing = D3DCREATE_HARDWARE_VERTEXPROCESSING;
	else
		vertexProcessing = D3DCREATE_SOFTWARE_VERTEXPROCESSING;

	if(g_bIsFullScreen)
	{
		g_d3dpp.BackBufferWidth = g_d3ddm.Width;
		g_d3dpp.BackBufferHeight = g_d3ddm.Height;
		g_d3dpp.BackBufferCount = 1;
		g_d3dpp.FullScreen_RefreshRateInHz = g_d3ddm.RefreshRate; //D3DPRESENT_RATE_DEFAULT
	    g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_ONE;
	}
	else
	{
		if( FAILED( g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm)))
			return E_FAIL;
	}

    g_d3dpp.Windowed = !g_bIsFullScreen;
    g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    g_d3dpp.BackBufferFormat = g_d3ddm.Format;
	g_d3dpp.hDeviceWindow              = g_hWnd;
	g_d3dpp.EnableAutoDepthStencil     = true; 
	g_d3dpp.AutoDepthStencilFormat     = D3DFMT_D24S8;

    if(FAILED(g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
								   vertexProcessing, 
								   &g_d3dpp, &g_d3d_Device)))
	{
		return E_FAIL;
	}

	return S_OK;
}
//-----------------------------------------------------------------------------
void SetupCamera(HWND hWnd)
{
    D3DXMATRIX   matProj;
	D3DXMATRIX	 matCameraView;
	D3DXVECTOR3  cameraTarget;
    D3DXVECTOR3  cameraPos;

	// Set where camera is viewing from
	cameraPos.x = 0.0f;
	cameraPos.y = 0.0f;
	cameraPos.z = -10.0f;
	// Set what camera is looking at
	cameraTarget.x = 0.0f;
	cameraTarget.y = 0.0f;
	cameraTarget.z = 0.0f;

	// Setup Camera View
	D3DXMatrixLookAtLH( &matCameraView, 
						&cameraPos, 
						&cameraTarget, 
						&D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
	// Tell the device to use the camera view for the viewport
	g_d3d_Device->SetTransform( D3DTS_VIEW, &matCameraView );

	// Setup Projection 
	RECT rect;
	GetClientRect(hWnd, &rect);
	float width = (float)rect.right, height = (float)rect.bottom;
	D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, width/height, 1.0f, 100.0f );
	// Tell the device to use the above matrix for projection
	g_d3d_Device->SetTransform( D3DTS_PROJECTION, &matProj );
}
//-----------------------------------------------------------------------------
bool RenderInit()
{
	HRESULT hr = 0;

	hr = D3DXCreateMeshFVF(
		12,
		24,
		D3DXMESH_MANAGED,
		Vertex::FVF,
		g_d3d_Device,
		&g_pMesh);

	if(FAILED(hr))
		return false;

	Vertex* v = 0;
	g_pMesh->LockVertexBuffer(0, (void**)&v);

	// fill in the front face vertex data
	v[0] = Vertex(-1.0f, -1.0f, -1.0f, 0.0f, 0.0f, -1.0f, 0.0f, 0.0f);
	v[1] = Vertex(-1.0f,  1.0f, -1.0f, 0.0f, 0.0f, -1.0f, 0.0f, 1.0f);
	v[2] = Vertex( 1.0f,  1.0f, -1.0f, 0.0f, 0.0f, -1.0f, 1.0f, 1.0f);
	v[3] = Vertex( 1.0f, -1.0f, -1.0f, 0.0f, 0.0f, -1.0f, 1.0f, 0.0f);

	// fill in the back face vertex data
	v[4] = Vertex(-1.0f, -1.0f, 1.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f);
	v[5] = Vertex( 1.0f, -1.0f, 1.0f, 0.0f, 0.0f, 1.0f, 0.0f, 1.0f);
	v[6] = Vertex( 1.0f,  1.0f, 1.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
	v[7] = Vertex(-1.0f,  1.0f, 1.0f, 0.0f, 0.0f, 1.0f, 1.0f, 0.0f);

	// fill in the top face vertex data
	v[8]  = Vertex(-1.0f, 1.0f, -1.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f);
	v[9]  = Vertex(-1.0f, 1.0f,  1.0f, 0.0f, 1.0f, 0.0f, 0.0f, 1.0f);
	v[10] = Vertex( 1.0f, 1.0f,  1.0f, 0.0f, 1.0f, 0.0f, 1.0f, 1.0f);
	v[11] = Vertex( 1.0f, 1.0f, -1.0f, 0.0f, 1.0f, 0.0f, 1.0f, 0.0f);

	// fill in the bottom face vertex data
	v[12] = Vertex(-1.0f, -1.0f, -1.0f, 0.0f, -1.0f, 0.0f, 0.0f, 0.0f);
	v[13] = Vertex( 1.0f, -1.0f, -1.0f, 0.0f, -1.0f, 0.0f, 0.0f, 1.0f);
	v[14] = Vertex( 1.0f, -1.0f,  1.0f, 0.0f, -1.0f, 0.0f, 1.0f, 1.0f);
	v[15] = Vertex(-1.0f, -1.0f,  1.0f, 0.0f, -1.0f, 0.0f, 1.0f, 0.0f);

	// fill in the left face vertex data
	v[16] = Vertex(-1.0f, -1.0f,  1.0f, -1.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	v[17] = Vertex(-1.0f,  1.0f,  1.0f, -1.0f, 0.0f, 0.0f, 0.0f, 1.0f);
	v[18] = Vertex(-1.0f,  1.0f, -1.0f, -1.0f, 0.0f, 0.0f, 1.0f, 1.0f);
	v[19] = Vertex(-1.0f, -1.0f, -1.0f, -1.0f, 0.0f, 0.0f, 1.0f, 0.0f);

	// fill in the right face vertex data
	v[20] = Vertex( 1.0f, -1.0f, -1.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f);
	v[21] = Vertex( 1.0f,  1.0f, -1.0f, 1.0f, 0.0f, 0.0f, 0.0f, 1.0f);
	v[22] = Vertex( 1.0f,  1.0f,  1.0f, 1.0f, 0.0f, 0.0f, 1.0f, 1.0f);
	v[23] = Vertex( 1.0f, -1.0f,  1.0f, 1.0f, 0.0f, 0.0f, 1.0f, 0.0f);

	g_pMesh->UnlockVertexBuffer();

	//
	// Define the triangles of the box
	//
	WORD* i = 0;
	g_pMesh->LockIndexBuffer(0, (void**)&i);

	// fill in the front face index data
	i[0] = 0; i[1] = 1; i[2] = 2;     
	i[3] = 0; i[4] = 2; i[5] = 3;

	// fill in the back face index data
	i[6] = 4; i[7]  = 5; i[8]  = 6;
	i[9] = 4; i[10] = 6; i[11] = 7;

	// fill in the top face index data
	i[12] = 8; i[13] =  9; i[14] = 10;
	i[15] = 8; i[16] = 10; i[17] = 11;

	// fill in the bottom face index data
	i[18] = 12; i[19] = 13; i[20] = 14;
	i[21] = 12; i[22] = 14; i[23] = 15;

	// fill in the left face index data
	i[24] = 16; i[25] = 17; i[26] = 18;
	i[27] = 16; i[28] = 18; i[29] = 19;

	// fill in the right face index data
	i[30] = 20; i[31] = 21; i[32] = 22;
	i[33] = 20; i[34] = 22; i[35] = 23;

	g_pMesh->UnlockIndexBuffer();

	DWORD* attributeBuffer = 0;
	g_pMesh->LockAttributeBuffer(0, &attributeBuffer);

	for(int a = 0; a < 4; a++)
		attributeBuffer[a] = 0;

	for(int b = 4; b < 8; b++)
		attributeBuffer[b] = 1;

	for(int c = 8; c < 12; c++)
		attributeBuffer[c] = 2;

	g_pMesh->UnlockAttributeBuffer();

	// Optimize the mesh to generate an attribute table.
	std::vector<DWORD> adjacencyBuffer(g_pMesh->GetNumFaces() * 3);
	g_pMesh->GenerateAdjacency(0.0f, &adjacencyBuffer[0]);

	hr = g_pMesh->OptimizeInplace(		
		D3DXMESHOPT_ATTRSORT |
		D3DXMESHOPT_COMPACT  |
		D3DXMESHOPT_VERTEXCACHE,
		&adjacencyBuffer[0],
		0, 0, 0);

	D3DXCreateTextureFromFile(g_d3d_Device, "brick0.jpg", &g_pTextures[0]);
	D3DXCreateTextureFromFile(g_d3d_Device, "brick1.jpg", &g_pTextures[1]);
	D3DXCreateTextureFromFile(g_d3d_Device, "checker.jpg", &g_pTextures[2]);

	g_d3d_Device->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	g_d3d_Device->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	g_d3d_Device->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_POINT);
	g_d3d_Device->SetRenderState(D3DRS_LIGHTING, false);

#ifdef _DEBUG
	// ϴ.
	//subSet  ľϱ ؼ ʿϴ. 
	DWORD numSubsets = 0;
	g_pMesh->GetAttributeTable(0,  &numSubsets);
#endif
	return true;
}
//-----------------------------------------------------------------------------
void DestroyDirect3D8()
{
	_RELEASE_<ID3DXMesh*>(g_pMesh);
	_RELEASE_<IDirect3DTexture9*>(g_pTextures[0]);
	_RELEASE_<IDirect3DTexture9*>(g_pTextures[1]);
	_RELEASE_<IDirect3DTexture9*>(g_pTextures[2]);

	_RELEASE_<LPDIRECT3DDEVICE9>(g_d3d_Device);
	_RELEASE_<LPDIRECT3D9>(g_d3d);
}
//-----------------------------------------------------------------------------
HRESULT ResetDeviceObjects()
{
	HRESULT hr;

    // Release all vidmem objects
    //if( FAILED( hr = InvalidateDeviceObjects() ) )
    //    return hr;

	// Reset the device
	if( FAILED( hr = g_d3d_Device->Reset( &g_d3dpp ) ) )
		return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT RenderLoop()
{
    HRESULT hr;

    // Test the cooperative level to see if it's okay to render
    if( FAILED( hr = g_d3d_Device->TestCooperativeLevel() ) )
    {
        // If the device was lost, do not render until we get it back
        if( D3DERR_DEVICELOST == hr )
            return S_OK;

        // Check if the device needs to be resized.
        if( D3DERR_DEVICENOTRESET == hr )
        {
            // If we are windowed, read the desktop mode and use the same format for
            // the back buffer
            if( !g_bIsFullScreen )
            {
				g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &g_d3ddm);
                g_d3dpp.BackBufferFormat = g_d3ddm.Format;
            }

            if( FAILED( hr = ResetDeviceObjects() ) )
                return hr;
        }
        return hr;
    }

	static float lastTime = (float)timeGetTime(); 
	float currTime  = (float)timeGetTime();
	float timeDelta = (currTime - lastTime)*0.001f;
	lastTime = currTime;

    // Render the scene as normal
    if( FAILED( hr = Render3D(timeDelta)))
        return hr;

	RenderMultiWindow( timeDelta * 10.0f );
	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT Render3D (float timeDelta)
{
	HRESULT hr;
	D3DXMATRIX xRot;
	D3DXMatrixRotationX(&xRot, D3DX_PI * 0.2f);

	static float y = 0.0f;
	D3DXMATRIX yRot;
	D3DXMatrixRotationY(&yRot, y);
	y += timeDelta;

	if( y >= 6.28f )
		y = 0.0f;

	D3DXMATRIX world = xRot * yRot;
	g_d3d_Device->SetTransform(D3DTS_WORLD, &world);

    g_d3d_Device->Clear (0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB (0, 0, 0), 1.0f, 0);
    g_d3d_Device->BeginScene ();

	for(int i = 0; i < g_nNumSubsets; i++)
	{
		g_d3d_Device->SetTexture( 0, g_pTextures[i] );
		g_pMesh->DrawSubset( i );
	}

    g_d3d_Device->EndScene ();
    hr = g_d3d_Device->Present (NULL, NULL, g_hWnd, NULL);
	return hr;
}
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	if(!AppInit(hInst, nCmdShow)) 
		return -1;
	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	SetupCamera(g_hWnd);

	if(!RenderInit())
		return -1;
	//DumpMesh();

	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( g_bActive )//&& m_bReady )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

	UnregisterClass( APPNAME, hInst);
	return 0;
}
//-----------------------------------------------------------------------------
void dumpVertices(std::ofstream& outFile, ID3DXMesh* mesh)
{
	outFile << "Vertices:" << std::endl;
	outFile << "---------" << std::endl << std::endl;

	Vertex* v = 0;
	mesh->LockVertexBuffer(0, (void**)&v);
	for(unsigned i = 0; i < mesh->GetNumVertices(); i++)
	{
		outFile << "Vertex " << i << ": (";
		outFile << v[i]._x  << ", " << v[i]._y  << ", " << v[i]._z  << ", ";
		outFile << v[i]._nx << ", " << v[i]._ny << ", " << v[i]._nz << ", ";
		outFile << v[i]._u  << ", " << v[i]._v  << ")"  << std::endl;
	}
	mesh->UnlockVertexBuffer();

	outFile << std::endl << std::endl;
}
//-----------------------------------------------------------------------------
void dumpIndices(std::ofstream& outFile, ID3DXMesh* mesh)
{
	outFile << "Indices:" << std::endl;
	outFile << "--------" << std::endl << std::endl;

	WORD* indices = 0;
	mesh->LockIndexBuffer(0, (void**)&indices);

	for(unsigned i = 0; i < mesh->GetNumFaces(); i++)
	{
		outFile << "Triangle " << i << ": ";
		outFile << indices[i * 3    ] << " ";
		outFile << indices[i * 3 + 1] << " ";
		outFile << indices[i * 3 + 2] << std::endl;
	}
	mesh->UnlockIndexBuffer();

	outFile << std::endl << std::endl;
}
//-----------------------------------------------------------------------------
void dumpAttributeBuffer(std::ofstream& outFile, ID3DXMesh* mesh)
{
	outFile << "Attribute Buffer:" << std::endl;
	outFile << "-----------------" << std::endl << std::endl;

	DWORD* attributeBuffer = 0;
	mesh->LockAttributeBuffer(0, &attributeBuffer);

	// an attribute for each face
	for(unsigned i = 0; i < mesh->GetNumFaces(); i++)
	{
		outFile << "Triangle lives in subset " << i << ": ";
		outFile << attributeBuffer[i] << std::endl;
	}
	mesh->UnlockAttributeBuffer();

	outFile << std::endl << std::endl;
}
//-----------------------------------------------------------------------------
void dumpAdjacencyBuffer(std::ofstream& outFile, ID3DXMesh* mesh)
{
	outFile << "Adjacency Buffer:" << std::endl;
	outFile << "-----------------" << std::endl << std::endl;

	// three enttries per face
	std::vector<DWORD> adjacencyBuffer(mesh->GetNumFaces() * 3);

	mesh->GenerateAdjacency(0.0f, &adjacencyBuffer[0]);

	for(unsigned i = 0; i < mesh->GetNumFaces(); i++)
	{
		outFile << "Triangle's adjacent to triangle " << i << ": ";
		outFile << adjacencyBuffer[i * 3    ] << " ";
		outFile << adjacencyBuffer[i * 3 + 1] << " ";
		outFile << adjacencyBuffer[i * 3 + 2] << std::endl;
	}

	outFile << std::endl << std::endl;
}
//-----------------------------------------------------------------------------
void dumpAttributeTable(std::ofstream& outFile, ID3DXMesh* mesh)
{
	outFile << "Attribute Table:" << std::endl;
	outFile << "----------------" << std::endl << std::endl;	

	// number of entries in the attribute table
	DWORD numEntries = 0;

	mesh->GetAttributeTable(0, &numEntries);

	std::vector<D3DXATTRIBUTERANGE> table(numEntries);

	mesh->GetAttributeTable(&table[0], &numEntries);

	for(unsigned i = 0; i < numEntries; i++)
	{
		outFile << "Entry " << i << std::endl;
		outFile << "-----------" << std::endl;

		outFile << "Subset ID:    " << table[i].AttribId    << std::endl;
		outFile << "Face Start:   " << table[i].FaceStart   << std::endl;
		outFile << "Face Count:   " << table[i].FaceCount   << std::endl;
		outFile << "Vertex Start: " << table[i].VertexStart << std::endl;
		outFile << "Vertex Count: " << table[i].VertexCount << std::endl;
		outFile << std::endl;
	}

	outFile << std::endl << std::endl;
}
//-----------------------------------------------------------------------------
// Dump the Mesh Data to file.
void DumpMesh()
{
	std::ofstream OutFile; // used to dump mesh data to file

	OutFile.open("Mesh Dump.txt");

	dumpVertices(OutFile, g_pMesh);
	dumpIndices(OutFile, g_pMesh);
	dumpAttributeTable(OutFile, g_pMesh); 	
	dumpAttributeBuffer(OutFile, g_pMesh);		
	dumpAdjacencyBuffer(OutFile, g_pMesh);
	
	OutFile.close();
}